### Eclipse Workspace Patch 1.0
#P org.jboss.tools.openshift.express.ui
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizardModel.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizardModel.java	(revision 39226)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/OpenShiftExpressApplicationWizardModel.java	(working copy)
@@ -36,7 +36,8 @@
 import com.openshift.express.client.OpenShiftApplicationNotAvailableException;
 import com.openshift.express.client.OpenShiftException;
 
-public class OpenShiftExpressApplicationWizardModel extends ObservableUIPojo implements IOpenShiftExpressWizardModel {
+public class OpenShiftExpressApplicationWizardModel extends ObservableUIPojo
+		implements IOpenShiftExpressWizardModel {
 
 	protected HashMap<String, Object> dataModel = new HashMap<String, Object>();
 
@@ -47,7 +48,8 @@
 		this(user, null, null);
 	}
 
-	public OpenShiftExpressApplicationWizardModel(IUser user, IProject project, IApplication application) {
+	public OpenShiftExpressApplicationWizardModel(IUser user, IProject project,
+			IApplication application) {
 		// default value(s)
 		setUser(user);
 		setProject(project);
@@ -56,7 +58,8 @@
 		setCreateServerAdapter(true);
 		setRepositoryPath(DEFAULT_REPOSITORY_PATH);
 		setRemoteName(NEW_PROJECT_REMOTE_NAME_DEFAULT);
-		setServerType(ServerCore.findServerType(ExpressServerUtils.OPENSHIFT_SERVER_TYPE));
+		setServerType(ServerCore
+				.findServerType(ExpressServerUtils.OPENSHIFT_SERVER_TYPE));
 		setPublicationMode(PUBLISH_SOURCE);
 	}
 
@@ -73,33 +76,33 @@
 	 * @throws IOException
 	 */
 	@Override
-	public void importProject(IProgressMonitor monitor) throws OpenShiftException, CoreException, InterruptedException,
+	public void importProject(IProgressMonitor monitor)
+			throws OpenShiftException, CoreException, InterruptedException,
 			URISyntaxException, InvocationTargetException, IOException {
-		List<IProject> importedProjects =
-				new ImportNewProject(
-						getProjectName()
-						, getApplication()
-						, getRemoteName()
-						, getRepositoryFile())
-						.execute(monitor);
+		List<IProject> importedProjects = new ImportNewProject(
+				getProjectName(), getApplication(), getRemoteName(),
+				getRepositoryFile()).execute(monitor);
 		String appName = getApplication().getName();
 		String host = getApplication().getApplicationUrl();
 		IServer found = findServer(appName, host);
-		if( found == null )
-			createServerAdapter(monitor, importedProjects);
-		else {
-			new ServerAdapterFactory().addModules(found, importedProjects, monitor);
+		if (isCreateServerAdapter()) {
+			if (found == null)
+				createServerAdapter(monitor, importedProjects);
+			else {
+				new ServerAdapterFactory().addModules(found, importedProjects,
+						monitor);
+			}
 		}
 	}
-	
+
 	private IServer findServer(String appName, String host) {
 		IServer[] all = ServerCore.getServers();
-		for( int i = 0; i < all.length; i++ ) {
+		for (int i = 0; i < all.length; i++) {
 			String host1 = all[i].getHost();
 			String app1 = ExpressServerUtils.getExpressApplicationName(all[i]);
-			if( (host.endsWith("/" + host1 + "/") || (host.endsWith("/" + host1)))
-					&& appName.equals(app1))
-					return all[i];
+			if ((host.endsWith("/" + host1 + "/") || (host
+					.endsWith("/" + host1))) && appName.equals(app1))
+				return all[i];
 		}
 		return null;
 	}
@@ -131,13 +134,11 @@
 	 */
 	@Override
 	public void configureUnsharedProject(IProgressMonitor monitor)
-			throws OpenShiftException, InvocationTargetException, InterruptedException, IOException, CoreException,
+			throws OpenShiftException, InvocationTargetException,
+			InterruptedException, IOException, CoreException,
 			URISyntaxException {
 		List<IProject> importedProjects = new ConfigureUnsharedProject(
-				getProjectName()
-				, getApplication()
-				, getRemoteName()
-				, getUser())
+				getProjectName(), getApplication(), getRemoteName(), getUser())
 				.execute(monitor);
 		createServerAdapter(monitor, importedProjects);
 	}
@@ -169,22 +170,22 @@
 	 */
 	@Override
 	public void configureGitSharedProject(IProgressMonitor monitor)
-			throws OpenShiftException, InvocationTargetException, InterruptedException, IOException, CoreException,
+			throws OpenShiftException, InvocationTargetException,
+			InterruptedException, IOException, CoreException,
 			URISyntaxException {
 		List<IProject> importedProjects = new ConfigureGitSharedProject(
-				getProjectName()
-				, getApplication()
-				, getRemoteName()
-				, getUser())
+				getProjectName(), getApplication(), getRemoteName(), getUser())
 				.execute(monitor);
 		createServerAdapter(monitor, importedProjects);
 	}
 
-	private void createServerAdapter(IProgressMonitor monitor, List<IProject> importedProjects)
-			throws OpenShiftException {
-		Assert.isTrue(importedProjects.size() > 0);
-		IProject project = importedProjects.get(0);
-		new ServerAdapterFactory().create(project, this, monitor);
+	private void createServerAdapter(IProgressMonitor monitor,
+			List<IProject> importedProjects) throws OpenShiftException {
+		if (isCreateServerAdapter()) {
+			Assert.isTrue(importedProjects.size() > 0);
+			IProject project = importedProjects.get(0);
+			new ServerAdapterFactory().create(project, this, monitor);
+		}
 	}
 
 	@Override
@@ -286,7 +287,8 @@
 	}
 
 	private IProject getProject() {
-		return ResourcesPlugin.getWorkspace().getRoot().getProject(getProjectName());
+		return ResourcesPlugin.getWorkspace().getRoot()
+				.getProject(getProjectName());
 	}
 
 	@Override
@@ -346,7 +348,8 @@
 
 	@Override
 	public boolean setUseExistingApplication(boolean useExistingApplication) {
-		Boolean isUseExistingApplication = (Boolean) setProperty(USE_EXISTING_APPLICATION, useExistingApplication);
+		Boolean isUseExistingApplication = (Boolean) setProperty(
+				USE_EXISTING_APPLICATION, useExistingApplication);
 		return isUseExistingApplication != null && isUseExistingApplication;
 	}
 
@@ -354,37 +357,44 @@
 		setUseExistingApplication(application != null);
 	}
 
-	private void waitForAccessible(IApplication application, IProgressMonitor monitor)
-			throws OpenShiftApplicationNotAvailableException, OpenShiftException {
+	private void waitForAccessible(IApplication application,
+			IProgressMonitor monitor)
+			throws OpenShiftApplicationNotAvailableException,
+			OpenShiftException {
 		// monitor.subTask("waiting for application to become accessible...");
 		if (!application.waitForAccessible(APP_CREATION_TIMEOUT * 1000)) {
 			throw new OpenShiftApplicationNotAvailableException(NLS.bind(
-					OpenShiftExpressUIMessages.HOSTNAME_NOT_ANSWERING, application.getApplicationUrl()));
+					OpenShiftExpressUIMessages.HOSTNAME_NOT_ANSWERING,
+					application.getApplicationUrl()));
 		}
 	}
 
-	protected IApplication createApplication(String name, ICartridge cartridge, IProgressMonitor monitor)
-			throws OpenShiftApplicationNotAvailableException, OpenShiftException {
+	protected IApplication createApplication(String name, ICartridge cartridge,
+			IProgressMonitor monitor)
+			throws OpenShiftApplicationNotAvailableException,
+			OpenShiftException {
 		IUser user = getUser();
 		if (user == null) {
-			throw new OpenShiftException("Could not create application, have no valid user credentials");
+			throw new OpenShiftException(
+					"Could not create application, have no valid user credentials");
 		}
 		IApplication application = user.createApplication(name, cartridge);
 		waitForAccessible(application, monitor);
 		return application;
 	}
 
-	public void createApplication(IProgressMonitor monitor) throws OpenShiftApplicationNotAvailableException,
+	public void createApplication(IProgressMonitor monitor)
+			throws OpenShiftApplicationNotAvailableException,
 			OpenShiftException {
-		IApplication application = createApplication(getApplicationName(), getApplicationCartridge(), monitor);
+		IApplication application = createApplication(getApplicationName(),
+				getApplicationCartridge(), monitor);
 		setApplication(application);
 	}
 
 	@Override
 	public Set<IEmbeddableCartridge> getSelectedEmbeddableCartridges() {
 		@SuppressWarnings("unchecked")
-		Set<IEmbeddableCartridge> selectedEmbeddableCartridges =
-				(Set<IEmbeddableCartridge>) getProperty(KEY_SELECTED_EMBEDDABLE_CARTRIDGES);
+		Set<IEmbeddableCartridge> selectedEmbeddableCartridges = (Set<IEmbeddableCartridge>) getProperty(KEY_SELECTED_EMBEDDABLE_CARTRIDGES);
 		if (selectedEmbeddableCartridges == null) {
 			selectedEmbeddableCartridges = new HashSet<IEmbeddableCartridge>();
 			setSelectedEmbeddableCartridges(selectedEmbeddableCartridges);
@@ -396,7 +406,9 @@
 	@Override
 	public Set<IEmbeddableCartridge> setSelectedEmbeddableCartridges(
 			Set<IEmbeddableCartridge> selectedEmbeddableCartridges) {
-		return (Set<IEmbeddableCartridge>) setProperty(KEY_SELECTED_EMBEDDABLE_CARTRIDGES, selectedEmbeddableCartridges);
+		return (Set<IEmbeddableCartridge>) setProperty(
+				KEY_SELECTED_EMBEDDABLE_CARTRIDGES,
+				selectedEmbeddableCartridges);
 	}
 
 	@Override